#ifndef SPDATA_H
#define SPDATA_H

#include <string>

using namespace std;

enum spMessageType 
{
	none         = 0,
	alive        = 1,
	limit        = 2,
	quit         = 3,
	getip        = 4,
	ip           = 5,
	getstate     = 6,
	state        = 7,
	scn          = 8,
	trg          = 9,
	clr          = 10,
	cmd          = 11,
	dmx          = 12,
	univ         = 13,
	getserial    = 14,
	serial       = 15,
	univclr      = 16,
	getscnstate  = 17,
	scnstate     = 18,
	getcmdstate  = 19,
	getdmxstate  = 20,
	clrlist      = 21,
	cmdlist      = 22,
	timeline     = 23,
	tab          = 24,
	getswserial  = 25,
	setclock     = 26,
	getclock     = 27,
	masterslave  = 28,
	getuniverse  = 29,
	setnode      = 30,
	getnode      = 31,
	clockstate   = 32,
	nodestate    = 33,
	reboot       = 34,
	swicthmsmode = 35
};

struct Rgbw
{
    int r_;
    int g_;
    int b_;
	int w_;
};

struct Color
{
    Rgbw color_;	// color
    bool rgbw_;		// rgbw status
	bool s_;		// status on/off
	int a_;			// area
};

struct Command
{
    bool blackout_;	// blackout
    bool next_;		// next
    bool prev_;		// previous
    bool white_;	// white
    bool hold_;		// hold (pause)
    int dim_;		// dimmer
    int speed_;		// speed
	int a_;			// area
};

struct Timeline
{
    bool play_;		// play
    bool pause_;	// pause
    bool stop_;	    // stop
    bool go_;		// go
    bool prev_;		// previous
    bool next_;		// next
};

struct Clock
{
    int hour_;	    // hour
    int min_;		// minute
    int sec_;		// second
    int year_;		// year
    int month_;		// month
    int day_;		// day
};

struct Node
{
    string sn_;	    // short name
    string ln_;		// long name
    string ip_;		// ip
    string mask_;	// mask
    int subnet_;	// subnet
    int univ_;		// universe
    int cfg_;		// config
};

struct Scene
{
    string n_;		// name
    int id_;		// id
    int a_;			// area
    int l_;			// loops
    bool s_;		// status on/off
};

struct Trigger
{
    string n_;		// name
    int id_;		// id
    int a_;			// area
    bool s_;		// status on/off
};

struct DmxChan
{
    int c_;			// channel
	int u_;			// univers
    int l_;			// level
    bool s_;		// status on/off
};

struct DmxUniv
{
    unsigned char levels_[512]; // levels
    bool s_[512];				// status on/off
    bool changed_[512];			// changed in the last message
};


#endif // SPDATA_H
